## stringtie 1.3.5+dfsg

=== Makefile ===
#-- for now these MUST point to the included "samtools-0.x.x" and "gclib" sub-directories
BAM  := ./samtools-0.1.18
GDIR := ./gclib
#--

INCDIRS := -I. -I${GDIR} -I${BAM}

CXX   := $(if $(CXX),$(CXX),g++)

BASEFLAGS := -Wall -Wextra ${INCDIRS} -fsigned-char -D_FILE_OFFSET_BITS=64 \
-D_LARGEFILE_SOURCE -fno-strict-aliasing -fno-exceptions -fno-rtti
#for gcc 8+ add: -Wno-class-memaccess
GCCVER5 := $(shell expr `${CXX} -dumpversion | cut -f1 -d.` \>= 5)
ifeq "$(GCCVER5)" "1"
 BASEFLAGS += -Wno-implicit-fallthrough
endif

GCCVER8 := $(shell expr `${CXX} -dumpversion | cut -f1 -d.` \>= 8)
ifeq "$(GCCVER8)" "1"
  BASEFLAGS += -Wno-class-memaccess
endif

LINKER  := $(if $(LINKER),$(LINKER),g++)

LDFLAGS := $(if $(LDFLAGS),$(LDFLAGS),-g)

LDFLAGS += -L${BAM}

LIBS    := -lbam -lz

ifneq (,$(findstring nothreads,$(MAKECMDGOALS)))
 NOTHREADS=1
endif

#detect MinGW (Windows environment)
ifneq (,$(findstring mingw,$(shell ${CXX} -dumpmachine)))
 WINDOWS=1
endif

# MinGW32 GCC 4.5 link problem fix
#ifdef WINDOWS
ifneq (,$(findstring 4.5.,$(shell ${CXX} -dumpversion)))
 STATIC_CLIB=1
endif
#endif

# Misc. system commands
ifdef WINDOWS
 RM = del /Q
else
 RM = rm -f
endif

# File endings
ifdef WINDOWS
 EXE = .exe
else
 EXE =
endif

# Non-windows systems need pthread
ifndef WINDOWS
 ifndef NOTHREADS
   LIBS += -lpthread
 endif
endif

ifdef NOTHREADS
  BASEFLAGS += -DNOTHREADS
endif

DMACH := $(shell ${CXX} -dumpmachine)

ifneq (,$(filter %release %static, $(MAKECMDGOALS)))
  # -- release build
  RELEASE_BUILD=1
  CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O3)
  CXXFLAGS += -DNDEBUG $(BASEFLAGS)
else
  ifneq (,$(filter %memcheck %memdebug, $(MAKECMDGOALS)))
     #use sanitizer in gcc 4.9+
     MEMCHECK_BUILD=1
     GCCVER49 := $(shell expr `${CXX} -dumpversion | cut -f1,2 -d.` \>= 4.9)
     ifeq "$(GCCVER49)" "0"
       $(error gcc version 4.9 or greater is required for this build target)
     endif
     CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
     CXXFLAGS += -fno-omit-frame-pointer -fsanitize=undefined -fsanitize=address $(BASEFLAGS)
     ifeq "$(GCCVER5)" "1"
       CXXFLAGS += -fsanitize=bounds -fsanitize=float-divide-by-zero -fsanitize=vptr
       CXXFLAGS += -fsanitize=float-cast-overflow -fsanitize=object-size
       #CXXFLAGS += -fcheck-pointer-bounds -mmpx
     endif
     CXXFLAGS += -DDEBUG -D_DEBUG -DGDEBUG -fno-common -fstack-protector
     LIBS := -lasan -lubsan -ldl $(LIBS)
  else
     #just plain debug build
     DEBUG_BUILD=1
     CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
     ifneq (, $(findstring darwin, $(DMACH)))
        CXXFLAGS += -gdwarf-3
     endif
     CXXFLAGS += -DDEBUG -D_DEBUG -DGDEBUG $(BASEFLAGS)
  endif
endif

ifdef RELEASE_BUILD
 ifneq (,$(findstring static, $(MAKECMDGOALS)))
    STATIC_CLIB=1
 endif
endif

ifdef STATIC_CLIB
 LDFLAGS += -static-libstdc++ -static-libgcc
endif

ifdef DEBUG_BUILD
  #$(warning Building DEBUG version of stringtie.. )
  DBG_WARN=@echo
  DBG_WARN+='WARNING: built DEBUG version [much slower], use "make clean release" for a faster, optimized version of the program.'
endif

OBJS := ${GDIR}/GBase.o ${GDIR}/GArgs.o ${GDIR}/GStr.o ${GDIR}/GBam.o \
 ${GDIR}/gdna.o ${GDIR}/codons.o ${GDIR}/GFastaIndex.o ${GDIR}/GFaSeqGet.o ${GDIR}/gff.o 

ifneq (,$(filter %memtrace %memusage %memuse, $(MAKECMDGOALS)))
    CXXFLAGS += -DGMEMTRACE
    OBJS += ${GDIR}/proc_mem.o
endif

ifndef NOTHREADS
 OBJS += ${GDIR}/GThreads.o 
endif

%.o : %.cpp
	${CXX} ${CXXFLAGS} -c $< -o $@

OBJS += rlink.o tablemaker.o tmerge.o

all release static debug: stringtie${EXE}
memcheck memdebug: stringtie${EXE}
memuse memusage memtrace: stringtie${EXE}
nothreads: stringtie${EXE}

${GDIR}/GBam.o : $(GDIR)/GBam.h
stringtie.o : $(GDIR)/GBitVec.h $(GDIR)/GHash.hh $(GDIR)/GBam.h
rlink.o : rlink.h tablemaker.h $(GDIR)/GBam.h $(GDIR)/GBitVec.h
tmerge.o : rlink.h tmerge.h
tablemaker.o : tablemaker.h rlink.h
${BAM}/libbam.a: 
	cd ${BAM} && make lib
stringtie: ${BAM}/libbam.a $(OBJS) stringtie.o
	${LINKER} ${LDFLAGS} -o $@ ${filter-out %.a %.so, $^} ${LIBS}
	@echo
	${DBG_WARN}

.PHONY : clean cleanall cleanAll allclean

# target for removing all object files

#	echo $(PATH)
clean:
	${RM} stringtie${EXE} stringtie.o*  $(OBJS)
	${RM} core.*
allclean cleanAll cleanall:
	cd ${BAM} && make clean
	${RM} stringtie${EXE} stringtie.o* $(OBJS)
	${RM} core.*

=== debian/changelog ===
stringtie (1.3.5+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #924101)
    - Fixing accidentally omitted binary

 -- Steffen Moeller <moeller@debian.org>  Sat, 09 Mar 2019 15:07:37 +0100

=== debian/control ===
Source: stringtie
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>
Build-Depends: debhelper (>= 11),
 libbam-dev,
 libhts-dev,
 help2man
Standards-Version: 4.3.0
Homepage: http://ccb.jhu.edu/software/stringtie/
Vcs-Browser: https://salsa.debian.org/med-team/stringtie
Vcs-Git: https://salsa.debian.org/med-team/stringtie.git

Package: stringtie
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: assemble short RNAseq reads to transcripts
 The abundance of transcripts in a human tissue sample 
 can be determined by RNA sequencing. The exact sequence
 sampled may be random, depending on the technology used.
 And it may be short, i.e. shorter than the transcript.
 At some point, many shorter reads need to be assembled
 to the model the complete transcripts.
 .
 StringTie knows how to assemble of RNA-Seq into potential
 transcripts without the need of a reference genome and
 provides a quantification also of the splice variants.

## stringtie 1.3.6+dfsg

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 CXX   := $(if $(CXX),$(CXX),g++)
 
 BASEFLAGS := -Wall -Wextra ${INCDIRS} -fsigned-char -D_FILE_OFFSET_BITS=64 \
--D_LARGEFILE_SOURCE -fno-strict-aliasing -fno-exceptions -fno-rtti
+-D_LARGEFILE_SOURCE -std=c++0x -fno-strict-aliasing -fno-exceptions -fno-rtti
 #for gcc 8+ add: -Wno-class-memaccess
 GCCVER5 := $(shell expr `${CXX} -dumpversion | cut -f1 -d.` \>= 5)
 ifeq "$(GCCVER5)" "1"
@@ -96,7 +96,7 @@
   else
      #just plain debug build
      DEBUG_BUILD=1
-     CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
+     CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-ggdb -g3 -O0 -fvar-tracking-assignments -fno-omit-frame-pointer)
      ifneq (, $(findstring darwin, $(DMACH)))
         CXXFLAGS += -gdwarf-3
      endif

=== debian/changelog ===
stringtie (1.3.6+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper 12
  * Remove trailing whitespace in debian/control
  * DEP3

 -- Andreas Tille <tille@debian.org>  Wed, 10 Jul 2019 22:19:22 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 12~),
  libbam-dev,
  libhts-dev,
  help2man
@@ -16,7 +16,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: assemble short RNAseq reads to transcripts
- The abundance of transcripts in a human tissue sample 
+ The abundance of transcripts in a human tissue sample
  can be determined by RNA sequencing. The exact sequence
  sampled may be random, depending on the technology used.
  And it may be short, i.e. shorter than the transcript.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -I/usr/include/bamtools/api/
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -I/usr/include/bamtools/api/
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@


override_dh_auto_install:
	help2man ./stringtie -n StringTie -s 1 -o  debian/stringtie.1
	dh_auto_install

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/stringtie.1

=== debian/watch ===
version=4
opts="dversionmangle=auto,oversionmangle=s/$/+dfsg/,repack" \
http://ccb.jhu.edu/software/stringtie/ dl/stringtie-([\d\.]+)\.tar\.gz debian uupdate

## stringtie 2.0.4+ds

=== debian/changelog ===
stringtie (2.0.4+ds-3) unstable; urgency=medium

  * Team upload.
  * Stop building on any-i386, as htslib is not built there.

 -- Andrius Merkys <merkys@debian.org>  Fri, 06 Dec 2019 02:51:36 -0500

stringtie (2.0.4+ds-2) unstable; urgency=medium

  * Team upload.
  * Disabling tests, as they require network access.

 -- Andrius Merkys <merkys@debian.org>  Tue, 03 Dec 2019 05:14:02 -0500

stringtie (2.0.4+ds-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Set upstream metadata fields: Repository.
  * Adapted clean-up after build

 -- Steffen Moeller <moeller@debian.org>  Fri, 29 Nov 2019 12:26:46 +0100

=== debian/control ===
Source: stringtie
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libbam-dev,
               libhts-dev,
               help2man
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/med-team/stringtie
Vcs-Git: https://salsa.debian.org/med-team/stringtie.git
Homepage: http://ccb.jhu.edu/software/stringtie/

Package: stringtie
Architecture: any-amd64 arm64 armel armhf mips mips64el mipsel ppc64el s390x alpha hppa ia64 m68k powerpc powerpcspe ppc64 riscv64 sh4 sparc64 x32
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: assemble short RNAseq reads to transcripts
 The abundance of transcripts in a human tissue sample
 can be determined by RNA sequencing. The exact sequence
 sampled may be random, depending on the technology used.
 And it may be short, i.e. shorter than the transcript.
 At some point, many shorter reads need to be assembled
 to the model the complete transcripts.
 .
 StringTie knows how to assemble of RNA-Seq into potential
 transcripts without the need of a reference genome and
 provides a quantification also of the splice variants.

## stringtie 2.0.5+ds

=== debian/changelog ===
stringtie (2.0.5+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.0.5+ds

 -- Andrius Merkys <merkys@debian.org>  Thu, 12 Dec 2019 08:41:36 -0500

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,9 @@
 %:
 	dh $@
 
+# Disabling tests, as they require network access. In future, a multiple
+# upstream tarball could be created to pull in the required test files.
+override_dh_auto_test:
 
 override_dh_auto_install:
 	help2man ./stringtie -n StringTie -s 1 -o  debian/stringtie.1
@@ -18,3 +21,5 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -f debian/stringtie.1
+	rm -fr test_data
+	rm -f SuperReads_RNA/global-1/SuperReadsR/all_tests

## stringtie 2.0.6+ds

=== Makefile ===
--- 
+++ 
@@ -37,13 +37,6 @@
  WINDOWS=1
 endif
 
-# MinGW32 GCC 4.5 link problem fix
-#ifdef WINDOWS
-ifneq (,$(findstring 4.5.,$(shell ${CXX} -dumpversion)))
- STATIC_CLIB=1
-endif
-#endif
-
 # Misc. system commands
 ifdef WINDOWS
  RM = del /Q
@@ -61,7 +54,8 @@
 # Non-windows systems need pthread
 ifndef WINDOWS
  ifndef NOTHREADS
-   LIBS += -lpthread
+   LIBS := -pthread ${LIBS}
+   BASEFLAGS += -pthread
  endif
 endif
 
@@ -77,26 +71,35 @@
   CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O3)
   CXXFLAGS += -DNDEBUG $(BASEFLAGS)
 else
-  ifneq (,$(filter %memcheck %memdebug, $(MAKECMDGOALS)))
+  ifneq (,$(filter %memcheck %memdebug %tsan %tcheck %thrcheck, $(MAKECMDGOALS)))
      #use sanitizer in gcc 4.9+
-     MEMCHECK_BUILD=1
      GCCVER49 := $(shell expr `${CXX} -dumpversion | cut -f1,2 -d.` \>= 4.9)
      ifeq "$(GCCVER49)" "0"
        $(error gcc version 4.9 or greater is required for this build target)
      endif
      CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
-     CXXFLAGS += -fno-omit-frame-pointer -fsanitize=undefined -fsanitize=address $(BASEFLAGS)
+     SANLIBS :=
+     ifneq (,$(filter %tsan %tcheck %thrcheck, $(MAKECMDGOALS)))
+        # thread sanitizer only (incompatible with address sanitizer)
+        CXXFLAGS += -fno-omit-frame-pointer -fsanitize=thread -fsanitize=undefined $(BASEFLAGS)
+        SANLIBS := -ltsan
+     else
+        # address sanitizer
+        CXXFLAGS += -fno-omit-frame-pointer -fsanitize=undefined -fsanitize=address $(BASEFLAGS)
+        SANLIBS := -lasan
+     endif
      ifeq "$(GCCVER5)" "1"
        CXXFLAGS += -fsanitize=bounds -fsanitize=float-divide-by-zero -fsanitize=vptr
        CXXFLAGS += -fsanitize=float-cast-overflow -fsanitize=object-size
        #CXXFLAGS += -fcheck-pointer-bounds -mmpx
      endif
      CXXFLAGS += -DDEBUG -D_DEBUG -DGDEBUG -fno-common -fstack-protector
-     LIBS := -lasan -lubsan -ldl $(LIBS)
+     LIBS := ${SANLIBS} -lubsan -ldl ${LIBS}
   else
      #just plain debug build
      DEBUG_BUILD=1
-     CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-ggdb -g3 -O0 -fvar-tracking-assignments -fno-omit-frame-pointer)
+     CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
+     #CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-ggdb -g3 -O0 -fvar-tracking-assignments -fno-omit-frame-pointer)
      ifneq (, $(findstring darwin, $(DMACH)))
         CXXFLAGS += -gdwarf-3
      endif
@@ -111,7 +114,7 @@
 endif
 
 ifdef STATIC_CLIB
- LDFLAGS += -static-libstdc++ -static-libgcc
+ LDFLAGS += -static-libgcc -static-libstdc++
 endif
 
 ifdef DEBUG_BUILD
@@ -138,7 +141,7 @@
 OBJS += rlink.o tablemaker.o tmerge.o
 
 all release static debug: stringtie${EXE}
-memcheck memdebug: stringtie${EXE}
+memcheck memdebug tsan tcheck thrcheck: stringtie${EXE}
 memuse memusage memtrace: stringtie${EXE}
 nothreads: stringtie${EXE}
 
@@ -153,7 +156,8 @@
 	${LINKER} ${LDFLAGS} -o $@ ${filter-out %.a %.so, $^} ${LIBS}
 	@echo
 	${DBG_WARN}
-
+test demo tests: stringtie${EXE}
+	@./run_tests.sh
 .PHONY : clean cleanall cleanAll allclean
 
 # target for removing all object files

=== debian/changelog ===
stringtie (2.0.6+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.0.6+ds
  * Excluding SuperReads_RNA/, as it is not used, and contains a lot of
    files with unaccounted for licensing.
  * The source is licensed under Expat.
  * Building on all architectures.

 -- Andrius Merkys <merkys@debian.org>  Mon, 23 Dec 2019 10:25:43 -0500

## stringtie 2.1.1+ds

=== debian/changelog ===
stringtie (2.1.1+ds-2) unstable; urgency=medium

  * Team upload

  [ Helmut Grohne ]
  * Improve cross building: Pass LINKER. (Closes: #950969)

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Sun, 09 Feb 2020 07:51:25 +0100

stringtie (2.1.1+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.1.1+ds

 -- Andrius Merkys <merkys@debian.org>  Fri, 07 Feb 2020 10:33:31 -0500

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
                libbam-dev,
                libhts-dev,
                help2man
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/stringtie
 Vcs-Git: https://salsa.debian.org/med-team/stringtie.git
 Homepage: http://ccb.jhu.edu/software/stringtie/
 
 Package: stringtie
-Architecture: any-amd64 arm64 armel armhf mips mips64el mipsel ppc64el s390x alpha hppa ia64 m68k powerpc powerpcspe ppc64 riscv64 sh4 sparc64 x32
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: assemble short RNAseq reads to transcripts

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,15 @@
 %:
 	dh $@
 
+override_dh_auto_build:
+	dh_auto_build -- 'LINKER=$$(CXX)'
+
 # Disabling tests, as they require network access. In future, a multiple
 # upstream tarball could be created to pull in the required test files.
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	echo "Disabling tests, as they require network access."
+endif
 
 override_dh_auto_install:
 	help2man ./stringtie -n StringTie -s 1 -o  debian/stringtie.1

=== debian/watch ===
version=4
opts="dversionmangle=auto,oversionmangle=s/$/+ds/,repack" \
http://ccb.jhu.edu/software/stringtie/ dl/stringtie-([\d\.]+)\.tar\.gz debian uupdate

## stringtie 2.1.2+ds

=== debian/changelog ===
stringtie (2.1.2+ds-1) unstable; urgency=medium

  * New upstream version
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Removed "debian uupdate" from d/watch

 -- Steffen Moeller <moeller@debian.org>  Mon, 27 Apr 2020 15:44:50 +0200

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
 Vcs-Browser: https://salsa.debian.org/med-team/stringtie
 Vcs-Git: https://salsa.debian.org/med-team/stringtie.git
 Homepage: http://ccb.jhu.edu/software/stringtie/
+Rules-Requires-Root: no
 
 Package: stringtie
 Architecture: any

## stringtie 2.1.4+ds

=== debian/changelog ===
stringtie (2.1.4+ds-4) unstable; urgency=medium

  * Do not run on armhf

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 14 Nov 2020 13:38:57 +0530

stringtie (2.1.4+ds-3) unstable; urgency=medium

  * Team Upload.
  * Fix test for non-amd64

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 03 Nov 2020 00:04:56 +0530

stringtie (2.1.4+ds-2) unstable; urgency=medium

  * Team upload.

 -- Andreas Tille <tille@debian.org>  Mon, 02 Nov 2020 08:36:50 +0100

stringtie (2.1.4+ds-1) unstable; urgency=medium

  * Team Upload.
  [ Steffen Moeller ]
  * New upstream version
  * Shortened short description of examples
  * upstream suggests cufflinks for post-processing

  [ Andreas Tille ]
  * Remove non-informational entry from changelog
  * Fix comparison file for test output
  * More comparison file fixes

  [ Nilesh Patra ]
  * Remove data and extra binary - use multi-orig tarball instead
  * New upstream version 2.1.4+ds
  * Fix tests

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 01 Nov 2020 22:15:22 +0530

stringtie (2.1.2+ds-2) unstable; urgency=medium

  * Team Upload.
  * Add binary: stringtie-examples
  * Add autopkgtests
  * Install relevant examples
  * s/http/https/ debian/control
  * compat version: 13

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 23 Aug 2020 12:37:28 +0530

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,24 @@
 Source: stringtie
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Steffen Moeller <moeller@debian.org>
+Uploaders: Steffen Moeller <moeller@debian.org>, Nilesh Patra <npatra974@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libbam-dev,
                libhts-dev,
                help2man
 Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/stringtie
 Vcs-Git: https://salsa.debian.org/med-team/stringtie.git
-Homepage: http://ccb.jhu.edu/software/stringtie/
+Homepage: https://ccb.jhu.edu/software/stringtie/
 Rules-Requires-Root: no
 
 Package: stringtie
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Recommends: stringtie-examples
+Suggests: cufflinks
 Description: assemble short RNAseq reads to transcripts
  The abundance of transcripts in a human tissue sample
  can be determined by RNA sequencing. The exact sequence

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, samtools
Restrictions: allow-stderr
Architecture: amd64 arm64 ppc64el i386

## stringtie 2.1.6+ds

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 CXX   := $(if $(CXX),$(CXX),g++)
 
 BASEFLAGS := -Wall -Wextra ${INCDIRS} -fsigned-char -D_FILE_OFFSET_BITS=64 \
--D_LARGEFILE_SOURCE -std=c++0x -fno-strict-aliasing -fno-exceptions -fno-rtti
+-D_LARGEFILE_SOURCE -std=c++11 -fno-strict-aliasing -fno-exceptions -fno-rtti
 #for gcc 8+ add: -Wno-class-memaccess
 GCCVER5 := $(shell expr `${CXX} -dumpversion | cut -f1 -d.` \>= 5)
 ifeq "$(GCCVER5)" "1"
@@ -28,7 +28,7 @@
 
 LIBS    := -lbam -lz
 
-ifneq (,$(findstring nothreads,$(MAKECMDGOALS)))
+ifneq (,$(filter %nothreads %prof %profile, $(MAKECMDGOALS)))
  NOTHREADS=1
 endif
 
@@ -38,11 +38,11 @@
 endif
 
 # Misc. system commands
-ifdef WINDOWS
- RM = del /Q
-else
- RM = rm -f
-endif
+#ifdef WINDOWS ##<-- use MSYS
+# RM = del /Q
+#else
+RM = rm -f
+#endif
 
 # File endings
 ifdef WINDOWS
@@ -96,14 +96,19 @@
      CXXFLAGS += -DDEBUG -D_DEBUG -DGDEBUG -fno-common -fstack-protector
      LIBS := ${SANLIBS} -lubsan -ldl ${LIBS}
   else
-     #just plain debug build
-     DEBUG_BUILD=1
-     CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
-     #CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-ggdb -g3 -O0 -fvar-tracking-assignments -fno-omit-frame-pointer)
-     ifneq (, $(findstring darwin, $(DMACH)))
-        CXXFLAGS += -gdwarf-3
+     ifneq (,$(filter %prof %profile, $(MAKECMDGOALS)))
+     ## profiling build
+       CXXFLAGS := -DNDEBUG $(BASEFLAGS) -g -pg
+       LDFLAGS += -g -pg
+     else
+        #just plain debug build
+        DEBUG_BUILD=1
+        CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
+        ifneq (, $(findstring darwin, $(DMACH)))
+           CXXFLAGS += -gdwarf-3
+        endif
+        CXXFLAGS += -DDEBUG -D_DEBUG -DGDEBUG $(BASEFLAGS)
      endif
-     CXXFLAGS += -DDEBUG -D_DEBUG -DGDEBUG $(BASEFLAGS)
   endif
 endif
 
@@ -143,16 +148,16 @@
 all release static debug: stringtie${EXE}
 memcheck memdebug tsan tcheck thrcheck: stringtie${EXE}
 memuse memusage memtrace: stringtie${EXE}
+prof profile: stringtie${EXE}
 nothreads: stringtie${EXE}
 
-${GDIR}/GBam.o : $(GDIR)/GBam.h
-stringtie.o : $(GDIR)/GBitVec.h $(GDIR)/GHash.hh $(GDIR)/GBam.h
+stringtie.o : $(GDIR)/GBitVec.h $(GDIR)/GHashMap.hh $(GDIR)/GBam.h
 rlink.o : rlink.h tablemaker.h $(GDIR)/GBam.h $(GDIR)/GBitVec.h
 tmerge.o : rlink.h tmerge.h
 tablemaker.o : tablemaker.h rlink.h
 ${BAM}/libbam.a: 
 	cd ${BAM} && make lib
-stringtie: ${BAM}/libbam.a $(OBJS) stringtie.o
+stringtie${EXE}: ${BAM}/libbam.a $(OBJS) stringtie.o
 	${LINKER} ${LDFLAGS} -o $@ ${filter-out %.a %.so, $^} ${LIBS}
 	@echo
 	${DBG_WARN}

=== debian/changelog ===
stringtie (2.1.6+ds-1) unstable; urgency=medium

  * New upstream version 2.1.6+ds
  * Declare compliance with policy 4.5.1
  * d/copyright: Minor Fix license name
  * Mark d/p/Makefile.patch as Forwarded: not-needed
  * Do not generate manpage at build, use maintainer manpage
    (This is done in order to make build cross-buildable)
  * d/p/hardening.patch: Add CPPFLAGS to compilation flags as
    hardening step (Fixes blhc)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 15 Aug 2021 19:34:16 +0530

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: stringtie
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Steffen Moeller <moeller@debian.org>, Nilesh Patra <npatra974@gmail.com>
+Uploaders: Steffen Moeller <moeller@debian.org>, Nilesh Patra <nilesh@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libbam-dev,
                libhts-dev,
                help2man
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/stringtie
 Vcs-Git: https://salsa.debian.org/med-team/stringtie.git
 Homepage: https://ccb.jhu.edu/software/stringtie/

## stringtie 2.2.1+ds

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,14 @@
 #-- for now these MUST point to the included "samtools-0.x.x" and "gclib" sub-directories
-BAM  := ./samtools-0.1.18
+HTSLIB  := ./htslib
+#-- 
+LIBDEFLATE := ${HTSLIB}/xlibs/lib/libdeflate.a
+LIBBZ2 := ${HTSLIB}/xlibs/lib/libbz2.a
+LIBLZMA := ${HTSLIB}/xlibs/lib/liblzma.a
+
 GDIR := ./gclib
 #--
 
-INCDIRS := -I. -I${GDIR} -I${BAM}
+INCDIRS := -I. -I${GDIR} -I${HTSLIB}
 
 CXX   := $(if $(CXX),$(CXX),g++)
 
@@ -24,9 +29,9 @@
 
 LDFLAGS := $(if $(LDFLAGS),$(LDFLAGS),-g)
 
-LDFLAGS += -L${BAM}
+# LDFLAGS += -L${BAM}
 
-LIBS    := -lbam -lz
+LIBS    := ${HTSLIB}/libhts.a ${LIBBZ2} ${LIBLZMA} ${LIBDEFLATE} -lz -lm
 
 ifneq (,$(filter %nothreads %prof %profile, $(MAKECMDGOALS)))
  NOTHREADS=1
@@ -44,13 +49,6 @@
 RM = rm -f
 #endif
 
-# File endings
-ifdef WINDOWS
- EXE = .exe
-else
- EXE =
-endif
-
 # Non-windows systems need pthread
 ifndef WINDOWS
  ifndef NOTHREADS
@@ -63,9 +61,21 @@
   BASEFLAGS += -DNOTHREADS
 endif
 
+# Compiling for Windows with MinGW?
+#ifneq ($(findstring -mingw,$(shell $(CC) -dumpmachine 2>/dev/null)),)
+#LIBS += -lregex -lws2_32
+#endif
+# File endings
+ifdef WINDOWS
+ EXE = .exe
+ LIBS += -lregex -lws2_32
+else
+ EXE =
+endif
+
 DMACH := $(shell ${CXX} -dumpmachine)
 
-ifneq (,$(filter %release %static, $(MAKECMDGOALS)))
+ifneq (,$(filter %release %static %static-cpp, $(MAKECMDGOALS)))
   # -- release build
   RELEASE_BUILD=1
   CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O3)
@@ -113,13 +123,16 @@
 endif
 
 ifdef RELEASE_BUILD
- ifneq (,$(findstring static, $(MAKECMDGOALS)))
-    STATIC_CLIB=1
+ ifneq ($(findstring static,$(MAKECMDGOALS)),) 
+  # static or static-cpp found
+  ifneq ($(findstring static-cpp,$(MAKECMDGOALS)),) 
+     #not a full static build, only c/c++ libs
+     LDFLAGS := -static-libgcc -static-libstdc++ ${LDFLAGS}
+  else
+     #full static build
+     LDFLAGS := -static -static-libgcc -static-libstdc++ ${LDFLAGS}
+  endif
  endif
-endif
-
-ifdef STATIC_CLIB
- LDFLAGS += -static-libgcc -static-libstdc++
 endif
 
 ifdef DEBUG_BUILD
@@ -128,7 +141,7 @@
   DBG_WARN+='WARNING: built DEBUG version [much slower], use "make clean release" for a faster, optimized version of the program.'
 endif
 
-OBJS := ${GDIR}/GBase.o ${GDIR}/GArgs.o ${GDIR}/GStr.o ${GDIR}/GBam.o \
+OBJS := ${GDIR}/GBase.o ${GDIR}/GArgs.o ${GDIR}/GStr.o ${GDIR}/GSam.o \
  ${GDIR}/gdna.o ${GDIR}/codons.o ${GDIR}/GFastaIndex.o ${GDIR}/GFaSeqGet.o ${GDIR}/gff.o 
 
 ifneq (,$(filter %memtrace %memusage %memuse, $(MAKECMDGOALS)))
@@ -145,19 +158,24 @@
 
 OBJS += rlink.o tablemaker.o tmerge.o
 
-all release static debug: stringtie${EXE}
+all release static static-cpp debug: stringtie${EXE}
 memcheck memdebug tsan tcheck thrcheck: stringtie${EXE}
 memuse memusage memtrace: stringtie${EXE}
 prof profile: stringtie${EXE}
 nothreads: stringtie${EXE}
 
-stringtie.o : $(GDIR)/GBitVec.h $(GDIR)/GHashMap.hh $(GDIR)/GBam.h
-rlink.o : rlink.h tablemaker.h $(GDIR)/GBam.h $(GDIR)/GBitVec.h
+stringtie.o : $(GDIR)/GBitVec.h $(GDIR)/GHashMap.hh $(GDIR)/GSam.h
+rlink.o : rlink.h tablemaker.h $(GDIR)/GSam.h $(GDIR)/GBitVec.h
 tmerge.o : rlink.h tmerge.h
 tablemaker.o : tablemaker.h rlink.h
-${BAM}/libbam.a: 
-	cd ${BAM} && make lib
-stringtie${EXE}: ${BAM}/libbam.a $(OBJS) stringtie.o
+
+##${BAM}/libbam.a: 
+##	cd ${BAM} && make lib
+
+${HTSLIB}/libhts.a:
+	cd ${HTSLIB} && ./build_lib.sh
+
+stringtie${EXE}: ${HTSLIB}/libhts.a $(OBJS) stringtie.o
 	${LINKER} ${LDFLAGS} -o $@ ${filter-out %.a %.so, $^} ${LIBS}
 	@echo
 	${DBG_WARN}
@@ -171,7 +189,7 @@
 clean:
 	${RM} stringtie${EXE} stringtie.o*  $(OBJS)
 	${RM} core.*
-allclean cleanAll cleanall:
-	cd ${BAM} && make clean
-	${RM} stringtie${EXE} stringtie.o* $(OBJS)
-	${RM} core.*
+##allclean cleanAll cleanall:
+##	cd ${BAM} && make clean
+##	${RM} stringtie${EXE} stringtie.o* $(OBJS)
+##	${RM} core.*

=== debian/changelog ===
stringtie (2.2.1+ds-2) unstable; urgency=medium

  * Remove libdeflate refs for now

 -- Nilesh Patra <nilesh@debian.org>  Sat, 19 Feb 2022 22:55:21 +0530

stringtie (2.2.1+ds-1) unstable; urgency=medium

  * Exclude htslib in d/copyright
  * New upstream version 2.2.1+ds
  * Add B-D on libdeflate-dev, libbzip2-dev
  * d/t/run-unit-test: Re-use code from run_tests.sh script
    instead of home-grown stuff
  * Adapt patches to newer release

 -- Nilesh Patra <nilesh@debian.org>  Sat, 19 Feb 2022 14:56:01 +0000

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                libbam-dev,
                libhts-dev,
+               libbz2-dev,
                help2man
 Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/stringtie

=== debian/rules ===
--- 
+++ 
@@ -20,12 +20,7 @@
 	echo "Disabling tests, as they require network access."
 endif
 
-override_dh_auto_install:
-	help2man ./stringtie -n StringTie -s 1 -o  debian/stringtie.1
-	dh_auto_install
-
 override_dh_auto_clean:
 	dh_auto_clean
-	rm -f debian/stringtie.1
 	rm -fr test_data
 	rm -f SuperReads_RNA/global-1/SuperReadsR/all_tests

=== debian/watch ===
version=4
opts="dversionmangle=auto,oversionmangle=s/$/+ds/,repack" \
http://ccb.jhu.edu/software/stringtie/ dl/stringtie-([\d\.]+)\.tar\.gz

## stringtie 3.0.3+ds

=== Makefile ===
--- 
+++ 
@@ -15,8 +15,8 @@
 BASEFLAGS := -Wall -Wextra ${INCDIRS} -fsigned-char -D_FILE_OFFSET_BITS=64 \
 -D_LARGEFILE_SOURCE -std=c++11 -fno-strict-aliasing -fno-exceptions -fno-rtti
 #for gcc 8+ add: -Wno-class-memaccess
-GCCVER5 := $(shell expr `${CXX} -dumpversion | cut -f1 -d.` \>= 5)
-ifeq "$(GCCVER5)" "1"
+GCCGTE5 := $(shell expr `${CXX} -dumpversion | cut -f1 -d.` \>= 5)
+ifeq "$(GCCGTE5)" "1"
  BASEFLAGS += -Wno-implicit-fallthrough
 endif
 
@@ -82,10 +82,8 @@
   CXXFLAGS += -DNDEBUG $(BASEFLAGS)
 else
   ifneq (,$(filter %memcheck %memdebug %tsan %tcheck %thrcheck, $(MAKECMDGOALS)))
-     #use sanitizer in gcc 4.9+
-     GCCVER49 := $(shell expr `${CXX} -dumpversion | cut -f1,2 -d.` \>= 4.9)
-     ifeq "$(GCCVER49)" "0"
-       $(error gcc version 4.9 or greater is required for this build target)
+     ifneq "$(GCCGTE5)" "1"
+       $(error g++ version 5 or greater is required for this build target)
      endif
      CXXFLAGS := $(if $(CXXFLAGS),$(CXXFLAGS),-g -O0)
      SANLIBS :=
@@ -98,7 +96,7 @@
         CXXFLAGS += -fno-omit-frame-pointer -fsanitize=undefined -fsanitize=address $(BASEFLAGS)
         SANLIBS := -lasan
      endif
-     ifeq "$(GCCVER5)" "1"
+     ifeq "$(GCCGTE5)" "1"
        CXXFLAGS += -fsanitize=bounds -fsanitize=float-divide-by-zero -fsanitize=vptr
        CXXFLAGS += -fsanitize=float-cast-overflow -fsanitize=object-size
        #CXXFLAGS += -fcheck-pointer-bounds -mmpx
@@ -156,7 +154,7 @@
 %.o : %.cpp
 	${CXX} ${CXXFLAGS} -c $< -o $@
 
-OBJS += rlink.o tablemaker.o tmerge.o
+OBJS += bundle.o rlink.o tablemaker.o tmerge.o
 
 all release static static-cpp debug: stringtie${EXE}
 memcheck memdebug tsan tcheck thrcheck: stringtie${EXE}
@@ -165,7 +163,8 @@
 nothreads: stringtie${EXE}
 
 stringtie.o : $(GDIR)/GBitVec.h $(GDIR)/GHashMap.hh $(GDIR)/GSam.h
-rlink.o : rlink.h tablemaker.h $(GDIR)/GSam.h $(GDIR)/GBitVec.h
+rlink.o : rlink.h tablemaker.h bundle.h $(GDIR)/GSam.h $(GDIR)/GBitVec.h
+bundle.o : bundle.h rlink.h tablemaker.h $(GDIR)/GSam.h
 tmerge.o : rlink.h tmerge.h
 tablemaker.o : tablemaker.h rlink.h
 
@@ -181,7 +180,7 @@
 	${DBG_WARN}
 test demo tests: stringtie${EXE}
 	@./run_tests.sh
-.PHONY : clean cleanall cleanAll allclean
+.PHONY : clean clean-htslib
 
 # target for removing all object files
 
@@ -189,6 +188,10 @@
 clean:
 	${RM} stringtie${EXE} stringtie.o*  $(OBJS)
 	${RM} core.*
+clean-all: clean
+	cd ${HTSLIB} && ./build_lib.sh clean
+clean-htslib:
+	cd ${HTSLIB} && ./build_lib.sh clean
 ##allclean cleanAll cleanall:
 ##	cd ${BAM} && make clean
 ##	${RM} stringtie${EXE} stringtie.o* $(OBJS)

=== debian/changelog ===
stringtie (3.0.3+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 3.0.3+ds
  * d/watch: update to v5 and point to Github.
  * d/copyright: document debian-tests-data component.
  * d/patches/*: unfuzz all patches.
  * Makefile.patch: normalize Last-Update timestamp.
  * d/control: drop redundant Priority: optional.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/control: declare compliance to standards version 4.7.3.
  * d/t/run-unit-test: update from run_tests.sh.
  * d/control: drop recommending stringtie-examples. (Closes: #1116097)

 -- Étienne Mollier <emollier@debian.org>  Mon, 05 Jan 2026 20:34:13 +0100

stringtie (2.2.1+ds-3) unstable; urgency=medium

  * Team upload.
  * Add prepDE.py3 (renamed to prepDE.py) to /usr/bin
    Closes: #1061576
  * Depends: python3
  * Lintian-overrides: script-with-language-extension
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 26 Jan 2024 21:34:48 +0100

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,22 @@
 Source: stringtie
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Steffen Moeller <moeller@debian.org>, Nilesh Patra <nilesh@debian.org>
+Uploaders: Steffen Moeller <moeller@debian.org>
 Section: science
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libbam-dev,
                libhts-dev,
                libbz2-dev,
                help2man
-Standards-Version: 4.5.1
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/stringtie
 Vcs-Git: https://salsa.debian.org/med-team/stringtie.git
 Homepage: https://ccb.jhu.edu/software/stringtie/
-Rules-Requires-Root: no
 
 Package: stringtie
 Architecture: any
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
-Recommends: stringtie-examples
+         ${misc:Depends},
+         python3
 Suggests: cufflinks
 Description: assemble short RNAseq reads to transcripts
  The abundance of transcripts in a human tissue sample

=== debian/watch ===
Version: 5

Template: Github
Owner: gpertea
Project: stringtie
Dversionmangle: auto
Oversionmangle: s/$/+ds/
Repack: yes

Component: debian-tests-data
Source: https://github.com/gpertea/stringtie/blob/master/tests/README.md
Matching-Pattern: https://github.com/gpertea/stringtie/raw/test_data/tests_@ANY_VERSION@@ARCHIVE_EXT@
Search-Mode: plain
Dversionmangle: auto
Oversionmangle: s/$/+ds/
Repack: yes
